/**
 * Created by Taipham on 3/12/14.
 */
'use strict';


angular.module('taxigoDriverApp')
    .controller('MainCtrl', ['$rootScope', '$scope', 'gmaps', '$timeout', 'auth', '$state', 'config', 'driver', '$location', 'fetchData', 'socketIoService', '$interval', 'logger', 'restful',
        function ($rootScope, $scope, gmaps, $timeout, auth, $state, config, driver, $location, fetchData, socketIoService, $interval, logger, restful) {

            /*Kiểm tra login có token thì main.js load luôn không qua login và load gmap*/

            var maxTimeWait = 35000;
            var loadHistory;
            var showAlert;
            var start;
            var end;
            var messCustomer;
            var media;

            function playAudio() {
                var src = '/android_asset/www/toq.mp3';
                media = new Media(src, success, error_error);
                media.play();
            }

            function pause(){
                media.pause();
            }
            function success() {
                // ignore
            }
            function error_error(e) {
                alert('great error');
                alert(e.message);
            }


            $scope.listHistory = [];
            $scope.directionInfo = {};

            showAlert = function (mess, title) {
                if (navigator.notification) {
                    navigator.notification.alert(
                        mess,  // message
                        alertDismissed,
                        title,
                        'OK'
                    );
                } else {
                    alert(mess);
                }
            };



            function alertDismissed() {
                // TODO: something
            }

            loadHistory = function () {
                var userId = auth.getUserId();
                var filter = [
                    {
                        property: 'driver',
                        value: userId,
                        type: 'string',
                        comparison: 'eq'
                    }
                ];
                var sorter = [
                    {
                        property: 'endAt',
                        direction: 'DESC'
                    }
                ];
                fetchData.getData('RouteHistories', 0, 1000, filter, sorter).then(function (result) {
                    //console.log(result.all());
                    $scope.listHistory = result.all();
                })
            };

            var loadCustomerInfo = function () {
                var uId = driver.getDirectionInfo()[0].customer.id;// '53573418dd6dd1887dfc5c41' ;
                restful.get({table: 'Users', id: uId}, function (resp) {

                })
            };

            $scope.listMessage = []; // cm : Danh sách tin nhắn

            $scope.goToCenter = function () {
                gmaps.direcCenter();
            };


            function load() {
                if (driver.getCurrentStatus() == 1 && driver.getRouteStatus() == 0) {
                    console.log('F5...');
                    $rootScope.acceptCustomer = true;
                    $rootScope.acceptCustomerStart = true;
                }

                if (driver.getRouteStatus() == 1) {
                    console.log('F5...');
                    $rootScope.acceptCustomer = true;
                    $rootScope.acceptCustomerStart = false;
                }
            }


            $scope.sendMessage = function (messageContent) {

                var emitData = {
                    from: auth.getUserName(),
                    to: driver.getDirectionInfo()[0].customer.deviceId.toLowerCase(),
                    name: 'MotoTaxi',
                    deviceId: config.deviceId,
                    content: messageContent,
                    time: new Date(),
                    status: 0
                };
                socket.emit('send:message', emitData);
                window.socketIo.emit('send:message', emitData);
                socketIoService.emit('send:message', emitData);
                console.log('send:message', emitData);

                $scope.listMessage.push(emitData);


            };


            socketIoService.on('receipt:message', function (data) {
                if (navigator.notification) {
                    navigator.notification.beep(1);
                    navigator.notification.alert(
                        'Conteudo : ' + data.content ,  // message
                        function (){},         // callback
                        'Mensagem ',            // title
                        'OK'                  // buttonName
                    );
                }else {
                    alert('Mensagem de Cliente : ' + data.content);
                }

                logger.info('socketIoService', 'receipt:message', data);
                /*$scope.listMessage.push(data);*/

            });


            if (driver.getDirectionInfo()) {
                $scope.directionInfo = driver.getDirectionInfo()[0];
                loadCustomerInfo();
            }

            $scope.checkCustomerEmtry = function () {
                $rootScope.readMess = false;
                if (driver.getDirectionInfo() == false) {
                    /* showAlert('Bạn chưa có khách hàng nào!', 'TaxiGo');*/
                    toastr.success('Você não tem quaisquer clientes');

                } else if ($rootScope.customerInfo.status == 2) {
                    showAlert('Cliente encerrou rota!', 'ClickMototaxi');
                } else {
                    $rootScope.switchListTaxi(3);
                    //TODO : you can action is here
                    console.log('Você pode agir aqui!!!');
                }
            };

            $scope.deleteRouter = function (status) {
                if (status) {
                    driver.updateRoute(driver.getDirectionInfo()[0].id, 3, function (err, result) {
                        if (err) {
                            showAlert('Aviso: erros acontecem! Não é possível cancelar a rota', 'TaxiGo');
                        } else {

                            //console.log('Destroy route ', result);
                            socketIo.emit('destroy:route', {
                                roomID: driver.getCurrentRoomID(),
                                status: 3,
                                customer: result.customer.deviceId,
                                driver: result.driver.username
                            });

                            driver.setCurrentRoomID(null);

                            driver.setCurrentStatus(0);
                            driver.setDirectionInfo(null);

                            angular.forEach(gmaps.listMarkerCustomer, function (v, k) {
                                gmaps.map.removeLayer(v);
                            });

                            if (gmaps.endPointMarker && gmaps.startPointMarker) {
                                gmaps.map.removeLayer(gmaps.endPointMarker);
                                gmaps.map.removeLayer(gmaps.startPointMarker);
                            }
                            if (gmaps.RoutePolyline) {
                                gmaps.map.removeLayer(gmaps.RoutePolyline);
                            }


                            gmaps.map.setZoom(17);

                            gmaps.map.panTo(gmaps.currentPoint.getLatLng());


                            toastr.success('Terminando o percurso com sucesso.');

                            $rootScope.acceptCustomer = false;
                            $rootScope.acceptCustomerStart = false;

                            //window.location.reload();

                        }
                    });

                } else {
                    if (driver.getDirectionInfo()[0].status == 0) { // going to position of customer

                        if (window.confirm('Tem certeza de que deseja cancelar esta rota?')) {
                            driver.updateRoute(driver.getDirectionInfo()[0].id, 4, function (err, result) {
                                if (err) {
                                    showAlert('Aviso: erros acontecem !. Não é possível cancelar a rota', 'TaxiGo');
                                } else {

                                    socketIo.emit('destroy:route', {
                                        roomID: driver.getCurrentRoomID(),
                                        status: 4,
                                        customer: result.customer.deviceId,
                                        driver: result.driver.username
                                    });


                                    driver.setCurrentRoomID(null);
                                    driver.setCurrentStatus(0);
                                    driver.setDirectionInfo(null);

                                    angular.forEach(gmaps.listMarkerCustomer, function (v, k) {
                                        gmaps.map.removeLayer(v);
                                    });

                                    if (gmaps.endPointMarker && gmaps.startPointMarker) {
                                        gmaps.map.removeLayer(gmaps.endPointMarker);
                                        gmaps.map.removeLayer(gmaps.startPointMarker);
                                    }
                                    if (gmaps.RoutePolyline) {
                                        gmaps.map.removeLayer(gmaps.RoutePolyline);
                                    }


                                    gmaps.map.setZoom(17);

                                    gmaps.map.panTo(gmaps.currentPoint.getLatLng());

                                    /*  $rootScope.tooltip.open('Thông báo : kết thúc trình thành công', 4000);*/
                                    toastr.success('Terminado o percurso com sucesso.');

                                    $rootScope.acceptCustomer = false;
                                    $rootScope.acceptCustomerStart = false;


                                }
                            });
                        }
                    } else {
                        if (window.confirm('Você quer finalizar a rota?')) {
                            driver.updateRoute(driver.getDirectionInfo()[0].id, 2, function (err, result) {
                                if (err) {
                                    /* showAlert('Thông báo : có lỗi xảy ra !. Không thể kết thúc lộ trình', 'TaxiGo');*/

                                    toastr.success('Ocorreu um erro e não pode ser terminado essa rota');
                                } else {

                                    socketIo.emit('destroy:route', {
                                        roomID: driver.getCurrentRoomID(),
                                        status: 2
                                    });

                                    driver.setCurrentRoomID(null);
                                    driver.setCurrentStatus(0);
                                    driver.setDirectionInfo(null);

                                    angular.forEach(gmaps.listMarkerCustomer, function (v, k) {
                                        gmaps.map.removeLayer(v);
                                    });

                                    if (gmaps.endPointMarker && gmaps.startPointMarker) {
                                        gmaps.map.removeLayer(gmaps.endPointMarker);
                                        gmaps.map.removeLayer(gmaps.startPointMarker);
                                    }
                                    if (gmaps.RoutePolyline) {
                                        gmaps.map.removeLayer(gmaps.RoutePolyline);
                                    }


                                    gmaps.map.setZoom(17);

                                    gmaps.map.panTo(gmaps.currentPoint.getLatLng());

                                    /*$rootScope.tooltip.open('Thông báo : kết thúc trình thành công', 4000);*/
                                    toastr.success('Rota finalizada com sucesso');

                                    $rootScope.acceptCustomer = false;
                                    $rootScope.acceptCustomerStart = false;


                                    //window.location.reload();
                                }
                            });
                        }
                    }
                }
            };

            $scope.startChat = function(){
                var messageContent = window.prompt("Enviar Recado: ");
                if(messageContent != null){
                    var emitData = {
                        roomID: driver.getCurrentRoomID(),
                        from: auth.getUserName(),
                        to: driver.getDirectionInfo()[0].customer.deviceId,
                        name: 'MotoTaxi',
                        deviceId: config.deviceId,
                        content: messageContent,
                        time: new Date(),
                        status: 1
                    };
                    socketIo.emit('send:recado', emitData);
                    console.log('send:message', emitData);

                }else{

                }
            }

            $scope.startRoute = function () {
                if (driver.getDirectionInfo()[0].status == 0) {
                    driver.updateRoute(driver.getDirectionInfo()[0].id, 1, function (err, result) {
                        if (err) {
                            /*showAlert('Thông báo : có lỗi xảy ra !. Không thể bắt đầu lộ trình', 'TaxiGo');*/

                            toastr.success('Ocorreu um erro, não pode terminar este percurso');

                        } else {
                            driver.setDirectionInfo([result]);

                            socketIo.emit('taxi:start:route', {
                                roomID: driver.getCurrentRoomID()
                            });

                            var startRouter = 'A rota foi iniciada!';
                            /*  $rootScope.tooltip.open(startRouter, 5000);*/

                            toastr.success('A Rota começou');
                            $rootScope.acceptCustomerStart = false;
                        }

                    });
                }
            };


            socketIo.on('customer:calling', function (data) {
                playAudio();
                var mess;
                if (navigator.notification) {
                    navigator.notification.beep(1);
                }
                if (driver.getCurrentStatus() !== 1) {

                    console.log('customer:calling', data);
                    console.log(data);
                    start = data.startPoint;
                    end = data.endPoint;
                    mess = 'Aceitar um pedido de cliente ?';
                    var d = new Date();

                    var bConfirm = true;

                    $("body").overHang({
                        // The activity
                        activity : "confirmation",
                        // Custom message
                        duration : 25,
                        message : mess,
                        // Custom color or theme
                        col : "flower"
                    });

                    $('#yes').click(function(){
                        pause();
                        angular.forEach(gmaps.listMarkerCustomer, function (v, k) {
                            gmaps.map.removeLayer(v);
                        });
                        data.carLic = auth.getUserName();
                        data.taxiId = auth.getUserId();

                        driver.setCurrentRoomID(data.roomID);
                        socketIo.emit('taxi:accept', data);
                        toastr.success('Cliente está inserindo endereço ...');
                    });

                    $('#no').click(function(){
                        pause();
                    });

                    var timeDiff = (new Date() - d);

                    if (timeDiff > maxTimeWait) {
                        var emitDataRemove = {
                            roomID: data.roomID,
                            deviceId: config.deviceId,
                            carLic: auth.getUserName(),
                            taxiId: auth.getUserId()
                        };
                        socketIo.emit('taxi:denied', emitDataRemove);
                        showAlert('Você perdeu um cliente!', 'TaxiGo');
                    }
                    else if (bConfirm) {

                        angular.forEach(gmaps.listMarkerCustomer, function (v, k) {
                            gmaps.map.removeLayer(v);
                        });
                        data.carLic = auth.getUserName();
                        data.taxiId = auth.getUserId();

                        driver.setCurrentRoomID(data.roomID);
                        socketIo.emit('taxi:accept', data);
                        toastr.success('Cliente recebeu informações.');
                    }
                    else {
                        var emitDataRemove = {
                            roomID: data.roomID,
                            deviceId: config.deviceId,
                            carLic: auth.getUserName(),
                            taxiId: auth.getUserId()
                        };

                        socketIo.emit('taxi:denied', emitDataRemove);
                        console.log("Você cancelou");
                    }
                }
            });


            /*Lắng nghe socket khách hàng chọn taxi*/


            socketIo.on('customer:choose:me', function (data) {

                if (navigator.notification) {
                    navigator.notification.beep(1);
                }

                console.log('customer:choose:me data', data);

                $scope.$apply(function () {
                    $scope.routeID = data.routeID;
                });
                driver.setCurrentRoomID(data.roomID);
                if (!data.isQuick) {
                    messCustomer = 'Cliente escolheu você! Localizacao: ' + start ;

                    if (confirm(messCustomer)) {

                        $rootScope.$apply(function () {
                            $rootScope.acceptCustomer = true;
                            $rootScope.acceptCustomerStart = true;
                        });

                        gmaps.createMarker(data);
                        gmaps.map.panTo(new L.LatLng(data.lat, data.lng));


                        driver.getDirection(data.routeId, function (err, result) {
                            if (result) {
                                console.log('getDirection', result);

                                driver.setCurrentStatus(1);
                                driver.setDirectionInfo(result);
                                $scope.directionInfo.startPoint = result[0].startPoint;
                                $scope.directionInfo.endPoint = result[0].endPoint;
                                $scope.directionInfo.status = result[0].status;

                                if(result[0].startPoint != result[0].endPoint){
                                    gmaps.getDirectionByGeoCode(result[0].startPoint, result[0].endPoint);
                                }



                            } else {
                                console.log('getDirection', err);
                            }
                        });
                    }else{
                        var rejectData = {
                            roomID: data.roomID,
                            carLic: auth.getUserName()
                        };
                        socketIo.emit('quick:taxi:reject', rejectData);
                    }

                } else {
                    /*$rootScope.tooltip.open('Lộ trình đã bắt đầu');*/
                    toastr.success('Inicio de Rota');
                    $rootScope.$apply(function () {
                        $rootScope.acceptCustomer = true;
                        $rootScope.acceptCustomerStart = true;
                    });

                    gmaps.createMarker(data);

                    driver.getDirection(data.routeId, function (err, result) {
                        if (result) {
                            driver.setCurrentStatus(1);
                            driver.setDirectionInfo(result);
                            $rootScope.customerInfo.startPoint = driver.getDirectionInfo()[0].startPoint;
                            $rootScope.customerInfo.endPoint = driver.getDirectionInfo()[0].endPoint;
                            $rootScope.customerInfo.status = driver.getDirectionInfo()[0].status;
                            //console.log('getDirection', result);
                        } else {
                            //console.log('getDirection', err);
                        }
                    });

                }
            });

            window.socketIo.on('customer:destroy:route', function (destroyData) {
                /* if (window.confirm('Khách hàng yêu cầu hủy lộ trình\n với lý do : ' + destroyData.reason
                 + ' . Bạn có đồng ý không ?')) {

                 }*/
                var messDelete = "O cliente cancelou a rota: " + destroyData.reason;
                showAlert(messDelete);
                // CM:  Tham số để xác định hủy lộ trình
                $scope.deleteRouter(1);
            });

            socketIoService.on('receipt:message', function (messageData) {

                if (navigator.notification) {
                    navigator.notification.beep(1);
                }
                $scope.listMessage.push(messageData);
                $rootScope.readMess = true;
            });

            gmaps.init();


            loadHistory();


            /*
             * Quick Call Taxi
             * */

            socketIo.on('quick:customer:calling', function (data) {
                var msg = 'Tem cliente solicitando corrida\n' + data.startPoint;
                playAudio();

                if (navigator.notification) {
                    navigator.notification.beep(1);
                }
                start = data.startPoint;
                end = data.endPoint;

                var startTime = new Date();

                var bConfirm = window.confirm(msg);

                var timeDiff = (new Date() - startTime);

                if (timeDiff > maxTimeWait) {
                    var rejectData = {
                        roomID: data.roomID,
                        carLic: auth.getUserName()
                    };
                    socketIo.emit('quick:taxi:reject', rejectData);
                    showAlert('Você perdeu um cliente', 'TaxiGo');
                }
                else if (bConfirm) {
                    /*angular.forEach(gmaps.listMarkerCustomer, function (v, k) {
                     v.setMap(null);
                     });*/
                    pause();
                    data.carLic = auth.getUserName();
                    data.taxiId = auth.getUserId();

                    driver.setCurrentRoomID(data.roomID);

                    console.log('quick:taxi:accept:request', 'start', true);
                    socketIo.emit('quick:taxi:accept:request', data);
                }
                else {
                    var emitDataRemove = {
                        roomID: data.roomID,
                        carLic: auth.getUserName()
                    };

                    socketIo.emit('quick:taxi:reject', emitDataRemove);
                    console.log("Você cancelou");
                }

                console.log('quick:customer:calling', data);
            });

            load();

        }]);
